#!/bin/sh


# einstein's puzzle: does the dane own the fish?
cpp -P <<EOD |
#define leftOf(X) ([pi1]((O X) + False))
#define rightMost [pi1] (False + (=n))
#define colour [pi2][pi1] 
#define nationality [pi2][pi2][pi1]
#define smoke [pi2][pi2][pi2][pi1] 
#define pet [pi2][pi2][pi2][pi2][pi1] 
#define drink [pi2][pi2][pi2][pi2][pi2]
  one | two | three | four | five ; \
  one <=> leftOf(two); \
  two <=> leftOf(three); \
  three <=> leftOf (four); \
  four <=> leftOf (five) ; \
  five <=> rightMost ; \
  nationality =brit <=> colour =red;  \
  nationality =swede <=> pet =dog; \
  nationality =dane <=> drink =tea ; \
  colour =green <=> leftOf (colour =white) ; \
  colour =green <=> drink =coffee ; \
  smoke =pallmall <=> pet =bird ; \
  colour =yellow <=> smoke =dunhill ; \
  three <=> drink =milk; \
  one <=> nationality =norwegian ; \
  smoke =blend <=> leftOf(pet =cat) | \
    pet =cat <=> leftOf (smoke =blend); \
  smoke =bluemaster <=> drink =beer; \
  pet=horse <=> leftOf(smoke =dunhill) | \
    smoke =dunhill  <=> leftOf(pet =horse); \
  nationality =german <=> smoke =prince; \
  nationality =norwegian  <=> leftOf(colour =blue) | \
    colour =blue  <=> leftOf (nationality =norwegian); \
  nationality =norwegian  <=> leftOf(colour =blue) | \
    colour =blue  <=> leftOf (nationality =norwegian); \
  smoke =blend   <=> leftOf(drink =water) | \
    drink =water  <=> leftOf (smoke =blend) \
  |- \
  pet =fish & nationality =dane
EOD
sed "s/one/one'/g;s/two/two'/g;s/three/three'/g;s/four/four'/g;
     s/five/five'/g" | 
../../coalg.native sat \
  "(Id + Const n)  \
   * (Const blue green red white yellow) \
   * (Const dane brit german swede norwegian) \
   * (Const blend bluemaster dunhill pallmall prince) \
   * (Const dog cat bird fish horse) \
   * (Const beer coffee milk tea water)" 
