#!/bin/bash -e


# install everything on a remote machine

[ -f FaCT++ ]   || { wget http://wwwcip.cs.fau.de/~re06huxa/pkg/FaCT++ && chmod +x FaCT++ ; }
[ -f tatl ]     || wget -O - http://atila.ibisc.univ-evry.fr/tableau_ATL/bin/tatl.tar.gz | tar xv

files=(
    coalg
    coalgcompare
    benchmarks/scripts/*

    FaCT++
    fact.conf

    cool2tatl/cool2tatl.sh
    tatl
    tatl-compatibility-wrapper.sh
)

#    $(ldd $(which FaCT++) | cut -d' ' -f3)
#    $(ldd coalg        | cut -d' ' -f3)
#    $(ldd coalgcompare | cut -d' ' -f3)

echo "==> sending files:"
printf ":: %s\n" "${files[@]}"

host="${1}:"
[ -z "$1" ] && host=""

rsync --copy-links -r "${files[@]}" "$host/${2:-/var/tmp/re06huxa/}"
